package com.gic.qywx.self;

import java.util.HashMap;
import java.util.Map;

import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.content.ByteArrayBody;
import org.apache.http.entity.mime.content.ContentBody;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/qywx")
public class QywxController {

    private static final Logger logger = LoggerFactory.getLogger(QywxController.class);

    @RequestMapping("self-post")
    public Object selfPost(String url, String json) {
        logger.info("自建post,url={},json={}", url, json);
        Map<String, Object> map = HttpClient.getWinxinResByJson(url, json);
        return map;
    }

    @RequestMapping("self-post-json")
    public Object selfPostJson(String url, @RequestBody String json) {
        logger.info("自建post json,url={},json={}", url, json);
        Map<String, Object> map = HttpClient.getWinxinResByJson(url, json);
        return map;
    }

    @RequestMapping("self-get")
    public Object selfGet(String url) {
        logger.info("自建get,url={}", url);
        Map<String, Object> map = HttpClient.getHttpByGet(url);
        return map;
    }

    @RequestMapping("self-upload")
    public Object selfUpload(String url, String fileUrl, String fileName) {
        logger.info("自建upload,url={}", url);
        byte[] data = CommonUtil.getFileByte(fileUrl);
        Map<String, ContentBody> paramsMap = new HashMap<String, ContentBody>();
        paramsMap.put("media", new ByteArrayBody(data, ContentType.DEFAULT_BINARY, fileName));
        Map<String, Object> map = HttpClient.getWinxinResByFile(url, paramsMap);
        return map;
    }

}
